                          #############   minio部署文档信息   #############
minio 离线镜像下载地址：
https://download.edoc2.com:5999/offlinepkg/minio/minio_prodv3.tar
下载后导入镜像：
docker load -i minio_prodv3.tar

#####################################################################################
一、# 部署minio前存储挂载准备三种模式之1 ——type one 纯单机单节点minio部署（单机k8s）：
                                      单机 单minio
#####################################################################################
1、## 单机纯allinone minio单机单点部署：
（1）、### 磁盘HHD一块大于1T存储空间；
（2）、### 记录磁盘uuid，使用df -Th && lsblk && blkid 命令查看：
   执行： mkdir -p /home/data/minio;
   磁盘挂载注入系统 UUID=2d8dcea3-3fab-4fd7-911b-28aa5052d794 /home/data/minio xfs defaults,noatime 0 0 ;
   执行： vim /etc/fstab    # 编辑完毕 保存退出 wq!
   编辑写入，UUID={此处为你自己挂载磁盘节点的uuid} /home/data/minio xfs defaults,noatime 0 0
（3）、### 挂载节点默认写死规范为 /home/data目录下(一定要修改，后期minio部署和挂载都需要跟着修改，需要联系技术支持)；
2、# 使用k8s部署纯单机单节点minio服务 
（1）、### 打minio运行节点标签（单机）
     执行： ONE_IP={你自己单机的宿主机 IP地址}                                      # 可以通过kubectl get node查看
     执行： kubectl label nodes $ONE_IP node.labels.nodelabels=Middleware         # 打入节点标签
（2）、### 登录单机项目目录 one-alone-minio 启动minio服务                            # 停止命令为 kubectl delete -f edoc2_minio.yaml 
     执行： cd one-alone-minio                                                      # minio-demo/one-alone-minio 目录下
     执行： sed -i "s#namespace:\ edoc2#namespace:\ 自定义命令空间名#g" ./*.yaml    # 默认edoc2不修改无需执行
     执行： kubectl apply -f edoc2_minio.yaml                                  
（3）、登录minio目录，cd pkg目录
     执行： namespace={输入你自己的namespace命令空间名}                                                         # 默认是edoc2
     执行： sleep 30                                                                                          # 等待30秒保证minio服务启动
     执行： minio_ip=`kubectl get svc -n $namespace | grep -v ominio | grep minio | awk -F " " '{print $3}'`
     执行： cd ../pkg/ && ./mc config host add minio http://$minio_ip:9000 admin root123456 --api s3v4
     执行： ./mc mb minio/edoc2                                                                                 # 核心桶
     执行： ./mc mb minio/edoc2docs                                                                             # 备用桶
备注1： 单机minio部署完毕，默认s3地址是内部ClusterIP:9000端口, 宿主机IP:9000:32900端口，默认s3账号admin，密码见edoc2_minio.yaml。
备注2： # 注意事项（之后部署服务使用minio配置说明提醒） 配置ecm-configmap.yaml对接使用minio s3对象存储，编辑 vim ecm-configmap.yaml 调整配置信息说明如下：
  # 通用S3配置 默认模式 1000
  STORAGEPLATFORM: "1000"
  # minio s3 配置 STORAGEPLATFORM 为10， 如果切换使用为10 minio专用模式 S3_HealthUrl S3_MgrAccount S3_MgrPassword 注释必须打开
  # STORAGEPLATFORM: "10"
  # minio s3 STORAGEPLATFORM 配置 为10 以下三行必须放开，minio s3 管理接口健康检测
  #S3_HealthUrl: "http://minio:9000"
  #S3_MgrAccount: "admin"
  #S3_MgrPassword: "root123456"



########################################################################################
二、# 部署minio前存储挂载准备三种模式之2 ——type two 单机多节点minio部署6节点（单机k8s）:
                      单机集群 6个network 6 drives节点 每drives对应一块盘 minio
########################################################################################
1、## 单机集群 6 drives节点 每drives对应一块盘 minio
（1）、### 磁盘HHD单机挂载6块，每块大于1T存储空间——（不挂载盘直接运行k8s 生产环境 minio服务后果自负）；；
（2）、### 记录磁盘uuid，使用df -Th && lsblk && blkid 命令查看：
   执行： mkdir -p /home/data/minio01;
   执行： mkdir -p /home/data/minio02;
   执行： mkdir -p /home/data/minio03;
   执行： mkdir -p /home/data/minio04;
   执行： mkdir -p /home/data/minio05;
   执行： mkdir -p /home/data/minio06;
   磁盘挂载注入系统 UUID=2d8dcea3-3fab-4fd7-911b-28aa5052d794 /home/data/minio-xxx xfs defaults,noatime 0 0;
   执行： vim /etc/fstab   # 编辑操作完毕 保存退出 wq!
   # 编辑写入以下信息:
   UUID={此处为你自己挂载磁盘节点的uuid hdd01} /home/data/minio01 xfs defaults,noatime 0 0
   UUID={此处为你自己挂载磁盘节点的uuid hdd02} /home/data/minio02 xfs defaults,noatime 0 0
   UUID={此处为你自己挂载磁盘节点的uuid hdd03} /home/data/minio03 xfs defaults,noatime 0 0
   UUID={此处为你自己挂载磁盘节点的uuid hdd04} /home/data/minio04 xfs defaults,noatime 0 0
   UUID={此处为你自己挂载磁盘节点的uuid hdd05} /home/data/minio05 xfs defaults,noatime 0 0
   UUID={此处为你自己挂载磁盘节点的uuid hdd06} /home/data/minio06 xfs defaults,noatime 0 0
（3）、### 挂载节点默认写死规范为 /home/data目录下(一定要修改，后期minio部署和挂载都需要跟着修改，需要联系技术支持)；
2、# 使用k8s部署 单机集群 6 drives节点 每drives对应一块盘 minio服务
（1）、### 打minio运行节点标签（k8s 单机）
     vim deploy_minio.sh     # 保存退出 wq! 详细见 WorkNode01={k8s单机的ip地址} 这段修改
（2）、### 登录minio项目目录 six-alone-minio 启动minio服务  
     执行： cd six-alone-minio                                                      # minio-demo/six-alone-minio 目录下
     执行： sed -i "s#namespace:\ edoc2#namespace:\ 自定义命令空间名#g" ./*.yaml    # 默认edoc2不修改无需执行
     执行： vim deploy_minio.sh     # 保存退出 wq!
     # 修改如下信息：
     #!/bin/bash
	# 修改为你自己的namespace名称，默认edoc2
	namespace=edoc2
	# 修改自己k8s主机节点，必须修改；
	WorkNode01={k8s单机的ip地址}
	SSH_PORT=22
	# 根据实际挂载点为磁盘大小分配pv磁盘空间，默认1000Gi
	pv_volume=1000Gi
	pv_yaml="minio-pv.yaml"
     启动执行： source deploy_minio.sh start                                                                  # 停止命令为 source deploy_minio.sh stop
### 如source deploy_minio.sh start 部成功 桶创建完毕忽略第三步骤手动创建桶命令行操作 ###
（3）、登录minio目录，cd pkg目录
     执行： namespace={输入你自己的namespace命令空间名}                                                         # 默认是edoc2
     执行： sleep 30                                                                                          # 等待30秒保证minio服务启动
     执行： minio_ip=`kubectl get svc -n $namespace | grep -v ominio | grep minio | awk -F " " '{print $3}'`
     执行： cd ../pkg/ && ./mc config host add minio http://$minio_ip:9000 admin root123456 --api s3v4
     执行： ./mc mb minio/edoc2                                                                                 # 核心桶
     执行： ./mc mb minio/edoc2docs                                                                             # 备用桶
备注1： 单机下部署minio集群完毕，默认s3地址是内部ClusterIP:9000端口, 宿主机IP:32900端口，默认s3账号admin，密码见edoc2_minio.yaml。
备注2： # 注意事项（之后部署服务使用minio配置说明提醒） 配置ecm-configmap.yaml对接使用minio s3对象存储，编辑 vim ecm-configmap.yaml 调整配置信息说明如下：
  # 通用S3配置 默认模式 1000
  STORAGEPLATFORM: "1000"
  # minio s3 配置 STORAGEPLATFORM 为10， 如果切换使用为10 minio专用模式 S3_HealthUrl S3_MgrAccount S3_MgrPassword 注释必须打开
  # STORAGEPLATFORM: "10"
  # minio s3 STORAGEPLATFORM 配置 为10 以下三行必须放开，minio s3 管理接口健康检测
  #S3_HealthUrl: "http://minio:9000"
  #S3_MgrAccount: "admin"
  #S3_MgrPassword: "root123456"

###########################################################################################
三、# 部署minio前存储挂载准备三种模式之3 ——type three 集群多节点minio部署12节点（集群k8s）：
           集群 3宿主机 12network 每个network对应一个drives节点 每个drives对应一块盘 / 部署 12节点 集群 minio
###########################################################################################
1、## 集群和原ceph标准产品包磁盘节点数配置同步，cluster minio 三宿主机12节点
（1）、### 磁盘HHD挂载3台宿主机 * 每台4块HHD——共12块，每块大于1T存储空间 ——（不挂载盘直接运行k8s 生产环境 minio服务后果自负）；
（2）、### 记录磁盘uuid，使用df -Th && lsblk && blkid 命令查看：
   #### 宿主机 k8s-node01
   执行： mkdir -p /home/data/minio01;
   执行： mkdir -p /home/data/minio04;
   执行： mkdir -p /home/data/minio07;
   执行： mkdir -p /home/data/minio10;
   磁盘挂载注入系统示例子样式 UUID=2d8dcea3-3fab-4fd7-911b-28aa5052d794 /home/data/minio-xxx xfs defaults,noatime 0 0
   执行： vim /etc/fstab                                                                                                 # 操作完毕 保存退出 wq!
   # 编辑写入以下信息: ({此处为你自己挂载磁盘节点的uuid hdd01} 请填写你自己主机挂载磁盘的uuid)
   UUID={此处为你自己挂载磁盘节点的uuid hdd01} /home/data/minio01 xfs defaults,noatime 0 0
   UUID={此处为你自己挂载磁盘节点的uuid hdd02} /home/data/minio04 xfs defaults,noatime 0 0
   UUID={此处为你自己挂载磁盘节点的uuid hdd03} /home/data/minio07 xfs defaults,noatime 0 0
   UUID={此处为你自己挂载磁盘节点的uuid hdd04} /home/data/minio10 xfs defaults,noatime 0 0
   #### 宿主机 k8s-node02
   执行： mkdir -p /home/data/minio02;
   执行： mkdir -p /home/data/minio05;
   执行： mkdir -p /home/data/minio08;
   执行： mkdir -p /home/data/minio11;
   磁盘挂载注入系统示例子样式 UUID=2d8dcea3-3fab-4fd7-911b-28aa5052d794 /home/data/minio-xxx  xfs defaults,noatime 0 0
   执行： vim /etc/fstab   # 保存退出 wq!
   # 编辑写入以下信息: ({此处为你自己挂载磁盘节点的uuid hdd01} 请填写你自己主机挂载磁盘的uuid)
   UUID={此处为你自己挂载磁盘节点的uuid hdd01} /home/data/minio02 xfs defaults,noatime 0 0
   UUID={此处为你自己挂载磁盘节点的uuid hdd02} /home/data/minio05 xfs defaults,noatime 0 0
   UUID={此处为你自己挂载磁盘节点的uuid hdd03} /home/data/minio08 xfs defaults,noatime 0 0
   UUID={此处为你自己挂载磁盘节点的uuid hdd04} /home/data/minio11 xfs defaults,noatime 0 0
   #### 宿主机 k8s-node03
   执行： mkdir -p /home/data/minio03;
   执行： mkdir -p /home/data/minio06;
   执行： mkdir -p /home/data/minio09;
   执行： mkdir -p /home/data/minio12;
   磁盘挂载注入系统示例子样式 UUID=2d8dcea3-3fab-4fd7-911b-28aa5052d794 /home/data/minio-xxx xfs defaults,noatime 0 0
   执行： vim /etc/fstab   # 保存退出 wq!
   # 编辑写入以下信息: ({此处为你自己挂载磁盘节点的uuid hdd01} 请填写你自己主机挂载磁盘的uuid)
   UUID={此处为你自己挂载磁盘节点的uuid hdd01} /home/data/minio03 xfs defaults,noatime 0 0
   UUID={此处为你自己挂载磁盘节点的uuid hdd02} /home/data/minio06 xfs defaults,noatime 0 0
   UUID={此处为你自己挂载磁盘节点的uuid hdd03} /home/data/minio09 xfs defaults,noatime 0 0
   UUID={此处为你自己挂载磁盘节点的uuid hdd04} /home/data/minio12 xfs defaults,noatime 0 0
（3）、### 挂载节点默认写死规范为 /home/data目录下(一定要修改，后期minio部署和挂载都需要跟着修改，需要联系技术支持)；
2、# 使用k8s3宿主机 12network 一一对应12drives节点 每个drives对应一块盘 / 部署 12节点 集群 minio：
（1）、### 打minio运行节点标签（k8s 集群 其中3节点运行）
     vim deploy_minio.sh     # 保存退出 wq! 
     # 详细见 集群三个节点名称，按照实际定义的node节点名，可以设置其它（但规则k8s工作节点主机名必须带node且必须唯一，角色区分）
	WorkNode01=k8s-node01
	WorkNode02=k8s-node02
	WorkNode03=k8s-node03
（2）、### 登录minio项目目录 cluster-minio 启动minio服务  
     执行： cd cluster-minio                                                              # minio-demo/cluster-minio 目录下
     执行： sed -i "s#namespace:\ edoc2#namespace:\ 自定义命令空间名#g" ./*.yaml          # 默认edoc2不修改无需执行
     执行： vim deploy_minio.sh     # 保存退出 wq!
     # 修改如下信息：
     #!/bin/bash
	# 修改为你自己的namespace名称，默认edoc2
	namespace=edoc2
	# 集群三个节点名称，按照实际定义的node节点名，可以设置其它（但规则k8s工作节点主机名必须带node且必须唯一，角色区分）
	WorkNode01=k8s-node01
	WorkNode02=k8s-node02
	WorkNode03=k8s-node03
	SSH_PORT=22
	# 根据实际挂载点为磁盘大小分配pv磁盘空间，默认1000Gi
	pv_volume=1000Gi
	pv_yaml="minio-pv.yaml"
     启动执行： source deploy_minio.sh start                                                                  # 停止命令为 source deploy_minio.sh stop
### 如source deploy_minio.sh start 部成功 桶创建完毕忽略第三步骤手动创建桶命令行操作 ###
（3）、登录minio目录，cd pkg目录
     执行： namespace={输入你自己的namespace命令空间名}                                                       # 默认是edoc2
     执行： sleep 30                                                                                          # 等待30秒保证minio服务启动
     执行： minio_ip=`kubectl get svc -n $namespace | grep -v ominio | grep minio | awk -F " " '{print $3}'`
     执行： cd ../pkg/ && ./mc config host add minio http://$minio_ip:9000 admin root123456 --api s3v4
     执行： ./mc mb minio/edoc2                                                                                 # 核心桶
     执行： ./mc mb minio/edoc2docs                                                                             # 备用桶
备注1： minio部署完毕，默认s3地址是内部ClusterIP:9000端口, 宿主机IP:32900端口，默认s3账号admin，密码见edoc2_minio.yaml。
备注2： # 注意事项（之后部署服务使用minio配置说明提醒） 配置ecm-configmap.yaml对接使用minio s3对象存储，编辑 vim ecm-configmap.yaml 调整配置信息说明如下：
  # 通用S3配置 默认模式 1000
  STORAGEPLATFORM: "1000"
  # minio s3 配置 STORAGEPLATFORM 为1000， 如果切换使用为10 minio专用模式 S3_HealthUrl S3_MgrAccount S3_MgrPassword 注释必须打开
  # STORAGEPLATFORM: "10"
  # minio s3 STORAGEPLATFORM 配置 为1000 以下三行必须放开，minio s3 管理接口健康检测
  #S3_HealthUrl: "http://minio:9000"
  #S3_MgrAccount: "admin"
  #S3_MgrPassword: "root123456"
