在CentOS 7.X上通过RPM包安装rclone：
一、# 安装rclone
1. 下载rclone的RPM包：
   ```bash
   wget https://downloads.rclone.org/v1.56.2/rclone-v1.56.2-linux-amd64.rpm
   ```
   这将从rclone官方网站下载v1.56.2版本的RPM包。确保你使用最新的版本来替换下载链接中的版本号。

2. 安装RPM包：
   ```bash
   sudo rpm -ivh rclone-v1.56.2-linux-amd64.rpm
   ```
   这将安装rclone包及其依赖项。

3. 验证安装：
   ```bash
   rclone --version
   ```
   运行以上命令，确认rclone安装成功并打印出版本信息。

4. 配置rclone：
   ```bash
   rclone config
   ```
   运行以上命令，按照交互式提示进行配置。你可以添加云存储服务（例如Google Drive、Amazon S3等），以及相应的访问凭据和设置。具体配置过程可以参考rclone文档或官方网站上的说明。

5. 使用rclone：
   使用rclone命令行工具和相应的命令参数，你可以执行各种操作，如文件同步、备份、上传、下载等。请参考rclone文档或运行`rclone --help`命令来查看可用的命令和选项。
请注意，上述步骤是基于CentOS 7.8的，并假设你已经具有适当的权限来安装软件包和进行配置。确保将上述命令中的RPM包名称和路径替换为实际的包名称和路径。此外，需要根据你的具体需求进行rclone的配置，并参考rclone文档以获得更详细的指南和使用示例。

要生成`~/.config/rclone/rclone.conf`默认配置文件，可以使用以下步骤：


##########################################################################################################################
1. 执行以下命令开始配置过程：
   ```bash
   rclone config
   ```

2. 输入以上命令后，将会显示一个交互式的配置向导，会提示你选择配置类型。按下 `n` 键，选择 "New remote" 来创建一个新的远程存储配置。

3. 接下来，你需要为新的远程存储配置指定一个名称，例如 `my-remote`。输入名称后，按下 `Enter` 键。

4. 根据你的云存储服务提供商的要求，选取适合你的存储服务。例如，如果你选择了 "Google Drive"，按下对应的编号并按下 `Enter` 键。

5. 按照提示，输入你的云存储服务的授权信息和其他设置。具体信息根据你选择的存储服务类型而有所不同。

6. 最后，当你完成了所有的配置选项后，向导会提示你保存配置。按下 `y` 键后，配置将被保存到`~/.config/rclone/rclone.conf`文件中。

现在，你已经生成了默认配置文件 `~/.config/rclone/rclone.conf`。接下来，你可以使用Vim编辑器或其他文本编辑器来修改这个配置文件，以便进行进一步的自定义配置。

例如，你可以运行以下命令使用Vim编辑器打开配置文件进行修改：
```bash
vim ~/.config/rclone/rclone.conf
```

然后，使用Vim编辑器的命令和功能来修改配置文件中的选项和值，以满足你的需求。保存并关闭文件后，你的rclone配置将会更新。
请注意，根据你的具体需求和云存储服务类型，配置文件的内容和格式可能会有所不同。确保参考rclone文档以了解更多关于配置文件的详细信息和可用的配置选项。

# cat ~/.config/rclone/rclone.conf
[minio]
type= s3
provider = Minio
access_key_id = admin
secret_access_key = root123456
endpoint = http://宿主机ip:31900

[oldminio]
type= s3
provider = Minio
access_key_id = admin
secret_access_key = root123456
endpoint = http://宿主机ip:31902

[allminio]
type= s3
provider = Minio
access_key_id = admin
secret_access_key = root123456
endpoint = http://宿主机ip:32900

# 使用rclone从桶备份到目录命令
# 桶到桶备份拷贝 （源 + 桶名： minio:edoc2，目标 + 桶名： allminio:nedoc2）
rclone copy --update --ignore-checksum --transfers=2 --checkers=2 --bwlimit=25M minio:edoc2 allminio:nedoc2
# 桶到本地目备份拷贝 （源 + 桶名： allminio:nedoc2，本地目录名： /data/backup/minio_back/nedoc2）
rclone copy --update --ignore-checksum --transfers=2 --checkers=2 --bwlimit=25M allminio:nedoc2 /data/backup/minio_back/nedoc2

